MurdejFormRadioTree = function(container) {
	this.search = true; 
	this.onChange = null;
	this.inModal = false;
	this.expanded = [];
	this.typeDuration = 2000;
};

MurdejFormRadioTree.prototype = {
	beforeIndex: function()
	{
		$(this.container).addClass('murdej-form-radio-tree');
		if (this.compact)
		{
			$(this.container).append($(
				'<div mu-id="valueLabel" class="value-label" tabindex="0"></div>'
				+ '<div mu-id="modal" class="modal" role="dialog"><div class="modal-dialog"><div class="modal-content"><div class="modal-body">'
				+ (this.search ? 'Hledat: <input type="search" class="search" mu-id="search" /><span mu-id="searchIcon"></span>' : '')
				+ '<span class="float-right">'
				+ '<span class="btn btn-xs btn-default" mu-id="clear">' + (this.clearButtonText || 'Nastavit prázdnou hodnotu') + '</span> &nbsp; '
				// + '<span class="close" mu-id="close">&times;</span>'
				+ '<span class="a" mu-id="close2" mu-click="close_click"><span class="icon-yes"></span></span>'
				+ '</span>'
				+ '<div mu-id="tree"></div>'
				+ '<div class="buttons"><span class="btn _btn-xs btn-primary" mu-id="close">Potvrdit a zavřít</span></div>'
				+ '</div></div></div></div>'
			));
		} 
		else 
		{
			$(this.container).append($(
				'<div>'
				+ (this.search ? 'Hledat: <input type="search" class="search" mu-id="search" />' : '')
				+ '<div mu-id="tree"></div>'
				+ '</div>'
			));
		}
	},
	afterIndex: function() 
	{
		var self = this;
		var opts = {
			extensions: [],
			source: this.items,
			selectMode: this.multiple ? 2 : 1,
			radiogroup: "_",
			checkbox: this.multiple ? "checkbox" : "radio",
			icon: false,
			activate: function(event, data) { },
			click: function(event, data) {
				if (data.targetType != "expander" && !self.multiple)
				{
					data.node.toggleExpanded();
					if (data.node.checkbox !== false)
					{
						data.node.setSelected(true);
						if (self.compact) self.closeModal();
					}
					return false;
				}
			},
			select: function(event, data) {
				if (self.multiple)
				{
					self.updateValues();
					// setTimeout(function() { self.updateValueLabel(); }, 1);
					self.updateValueLabelAsync();
				}
				else
				{
					self.ui.input.value = data.node.key;
					// if (this.onChange) this.onChange(this);
					// setTimeout(function() { self.updateValueLabel(); }, 1);
					self.updateValueLabelAsync();
				}
			}
		};
		if (this.search || this.searchUrl)
		{
			opts.extensions.push("filter");
			opts.quicksearch = true;
			opts.filter = {
				autoApply: true,   // Re-apply last filter if lazy data is loaded
				autoExpand: true, // Expand all branches that contain matches while filtered
				counter: true,     // Show a badge with number of matching child nodes near parent icons
				fuzzy: false,      // Match single characters in order, e.g. 'fb' will match 'FooBar'
				hideExpandedCounter: true,  // Hide counter badge if parent is expanded
				hideExpanders: false,       // Hide expanders if all child nodes are hidden by filter
				highlight: true,   // Highlight matches by wrapping inside <mark> tags
				leavesOnly: false, // Match end nodes only
				nodata: false,      // Display a 'no data' status node if result is empty
				mode: "hide"       // Grayout unmatched nodes (pass "hide" to remove unmatched node instead)
			};
		}
		if (this.lazyUrl)
		{
			opts.lazyLoad = function(event,data) 
			{
				data.result = { cache:false, url: self.lazyUrl.replace("__key__", data.node.key) };
			}
		}
		this.tree = $(this.ui.tree).fancytree(opts).fancytree("getTree");
		// vyber aktuální uzel
		this.updateSelected();
		
		// otevři
		setTimeout(function() { self.selectAndExpandRecursive(self.expanded, false); }, 1);

		if (this.inModal === null)
		{
			// autodetect modal
			var p = this.container;
			while(p)
			{
				if (p.classList.contains("modal")) break;
				p = p.parentElement;
			}
			this.inModal = !!p;
		}
	},
	updateSelected: function()
	{
		var nodes = [];
		if (this.multiple)
		{
			nodes = this.ui.input.value ? JSON.parse(this.ui.input.value) : [];
		} 
		else
		{
			if (this.ui.input.value) nodes = [this.ui.input.value];
		}
		this.selectAndExpandRecursive(nodes, true);
		// var node = this.tree.getNodeByKey(self.ui.input.value);
		this.updateValueLabelAsync();
	},
	selectAndExpandRecursive: function(nodes, select)
	{
		if (nodes)
		{
			for(var i = 0, l = nodes.length; i < l; i++)
			{
				var node = this.tree.getNodeByKey(nodes[i].toString());
				if (node) 
				{
					if (select) node.setSelected(true);
					while(node)
					{
						node.setExpanded(true);
						node = node.parent;
					};
				}
			}
		}
	},
	val: function(newValue)
	{
		if (newValue !== undefined)
		{
			this.ui.input.value = newValue;
			this.updateSelected();
		}
		else return this.ui.input.value;
	},
	updateValueLabel: function()
	{
		if (this.ui.valueLabel)
		{
			if (this.multiple)
			{
				this.ui.valueLabel.innerText = "";
				var nodes = this.tree.getSelectedNodes();
				if (nodes.length > 0)
				{
					for(var i = 0, l = nodes.length; i < l; i++)
					{
						var element = document.createElement('div');
						element.innerText = this.getNodeLabelPath(nodes[i]);
						this.ui.valueLabel.appendChild(element);
					}
				}
				else
				{
					this.ui.valueLabel.innerText = this.prompt || "Nevybrána ani jedna položka";
				}
			}
			else
			{
				var node = this.tree.getNodeByKey(this.ui.input.value);
				var valueLabel = "";
				if (node) 
				{
					// node.setSelected(true);
					valueLabel = this.getNodeLabelPath(node);
					/* while(node)
					{
						if (node.parent && (node.title || valueLabel)) valueLabel = node.title + ((node.title && valueLabel) ? " / " : "") + valueLabel;
						node = node.parent;
					} */
				} else valueLabel = this.prompt;
				this.ui.valueLabel.innerText = valueLabel;
			}
		};
		if (this.ui.clear) this.ui.clear.style.display = this.anySelected() ? 'inline-block' : 'none';
		if (this.onChange) this.onChange(this);
	},
	updateValueLabelAsync: function()
	{
		var self = this;
		setTimeout(function() { self.updateValueLabel(); }, 100);
	},
	updateValues: function()
	{
		var nodes = this.tree.getSelectedNodes();
		var values = [];
		for(var i = 0, l = nodes.length; i < l; i++)
		{
			values.push(nodes[i].key);
		}
		this.ui.input.value = JSON.stringify(values);
		if (this.onChange) this.onChange(this);
	},
	anySelected: function() 
	{
		var tmp = this.ui.input.value ? JSON.parse(this.ui.input.value) : null;
		return tmp && tmp.length;
	},
	getNodeLabelPath: function(node)
	{
		var valueLabel = "";
		while(node)
		{
			if (node.parent && (node.title || valueLabel)) valueLabel = node.title + ((node.title && valueLabel) ? " / " : "") + valueLabel;
			node = node.parent;
		}

		return valueLabel;
	},
	valueLabel_click: function()
	{
		this.openModal();
	},
	valueLabel_keypress: function(el, ev)
	{
		this.openModal();
	},
	search_keyup: function()
	{
		if (this.ui.search.value)
		{
			if (this.searchUrl)
			{
				this.serverSearch();
			}
			else
			{
				this.tree.filterNodes(this.ui.search.value);
			}
		}
		else this.tree.clearFilter();
	},
	searchIcon: function(icon)
	{
		// this.ui.searchIcon.innerText = icon;
	},
	serverSearch: function()
	{
		var self = this;
		self.searchIcon("typing");
		setTimeout(function() 
		{
			if (self.lastQ != self.ui.search.value)
			{
				self.serverSearch();
				self.lastQ = self.ui.search.value;
				return;
			} 
			self.searchIcon("search");
			if (self.lastSQ == self.lastQ) return;
			self.lastSQ = self.lastQ;
			$.ajax(
				self.searchUrl.replace("__q__", escape(self.ui.search.value)),
				{
					context: self,
					success: function(data) {
						self.searchIcon("found");
						this.addItemsRecursive(data);
						setTimeout(function()
						{
							self.tree.filterNodes(self.ui.search.value);
						}, 10);
					}
				}
			)
		}, this.typeDuration);
	},
	openModal: function()
	{
		if (this.inModal)
			this.ui.modal.classList.remove("modal");
		else
			$(this.ui.modal).modal();
		this.ui.search.focus();
	},
	closeModal: function()
	{
		if (this.inModal)
			this.ui.modal.classList.add("modal");
		else
			$(this.ui.modal).modal('hide');

	},
	clear_click: function() 
	{
		this.closeModal();
		this.ui.input.value = null;
		var tmp = this.tree.getSelectedNodes();
		for (var i = 0, l = tmp.length; i < l; i++)
		{
			tmp[i].setActive(false);
			tmp[i].setSelected(false);
		};
		this.ui.input.value = this.multiple ? "[]" : null;
		if (this.onChange) this.onChange(this);
		this.updateValueLabelAsync();
	},
	close_click: function() 
	{
		this.closeModal();
	},
	reload: function(items)
	{
		this.tree.reload(items);
	},
	addItemsRecursive: function(items, node)
	{
		var nodesByKey = {};
		if (node === undefined) node = this.tree.rootNode;
		var subnodes = node.children;
		if (subnodes)
		{
			for(var i=0, l=subnodes.length; i<l; i++)
			{
				nodesByKey[subnodes[i].key] = subnodes[i];
			}
		}
		for(var i=0, l=items.length; i<l; i++)
		{
			var item = items[i];
			var subNode = null;
			if (nodesByKey[item.key])
			{
				subNode = nodesByKey[item.key];
				// var s = subNode.isSelected();
				var cItem = Object.assign({}, item);
				delete cItem.children;
				subNode.fromDict(cItem);
				// subNode.setSelected(s);
			}
			else
			{
				subNode = node.addNode(item);
			}
			if (item.children)
			{
				this.addItemsRecursive(item.children, subNode);
			}
		}
	}
	/* lazyExpandValues: function(values)
	{
		var leftValues = values.slice();
		while(leftValues.length)
		{
			for(var i=0, l=leftValues.length; i < l; i++)
			{
				var n = this.tree.
			}
		}
	} */
}